<template>
    <div class="dsd-quality">
        <metadata-quality></metadata-quality>
        <distribution-quality></distribution-quality>
    </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';
import { has, isArray, isEmpty } from 'lodash-es';
import { helpers } from '@piveau/piveau-hub-ui-modules';
const { getTranslationFor } = helpers;

import MetadataQuality from './ECDatasetDetailsMetadataQuality.vue';
import DistributionQuality from './ECDatasetDetailsDistributionQuality.vue';

export default {
    name: 'datasetDetailsQuality',
    components: {
        MetadataQuality,
        DistributionQuality,
    },
    data() {
        return {
            isLoadingQualityData: true,
            isLoadingQualityDistributionData: true,
            useDQVDataDropdown: this.$env.content.datasetDetails.quality.useDQVDataDropdown,
            useQualityData: this.$env.content.datasetDetails.quality.useQualityData,
            useQualityDistributionData: this.$env.content.datasetDetails.quality.useQualityDistributionData,
            formats: this.$env.content.datasetDetails.quality.formatsDQVData,
        };
    },
    metaInfo() {
        return {
            title: this.$t('message.datasetDetails.subnav.quality'),
            meta: [
                {
                    name: 'description',
                    vmid: 'description',
                    content: (`${this.$t('message.datasetDetails.subnav.quality')} - ${this.getTranslationFor(this.getTitle, this.$route.query.locale, this.getLanguages)} - data.europa.eu`)?.substring(0, 4999),
                },
            ],
        };
    },
    computed: {
        ...mapGetters('datasetDetails', [
            'getIsDQVDataRequested',
            'getQualityDataRequested',
            'getLanguages',
            'getID',
        ]),
        isContentLoaded() {
            return !this.isLoadingQualityData && !this.isLoadingQualityDistributionData;
        }
    },
    methods: {
        ...mapActions('datasetDetails', [
            'loadDatasetDetails',
            'loadQualityData',
            'loadQualityDistributionData',
            'loadDQVData',
        ]),
        has,
        isArray,
        isEmpty,
        getTranslationFor,
        scrollToElement(id) {
            document.getElementById(id).scrollIntoView(true);
        },
        checkDistributionValidation() {
            let query = this.$route.query.validate;
            if (document.getElementById(query)) this.scrollToElement(query)
        },
    },
    created() {
        this.$nextTick(() => {

            // Duplicated API call, execute only if data not already loaded
            if (this.$route.params.ds_id !== this.getID) {
                this.$Progress.start();
                this.loadDatasetDetails(this.$route.params.ds_id)
                    .then(() => {
                        this.$Progress.finish();
                    })
                    .catch(() => {
                        this.$Progress.fail();
                        this.$router.replace({
                        name: 'NotFound',
                            query: { locale: this.$route.query.locale, dataset: this.$route.params.ds_id },
                        });
                    });
            }

            // Duplicated API call, execute only if data not already loaded
            if (this.$route.params.ds_id !== this.getQualityDataRequested) {

                if (this.useQualityData) {
                    this.$Progress.start();
                    this.isLoadingQualityData = true;
                    this.loadQualityData(this.$route.params.ds_id)
                        .then(() => this.$Progress.finish())
                        .catch(() => this.$Progress.fail())
                        .finally(() => this.isLoadingQualityData = false);
                }

                if (this.useQualityDistributionData) {
                    this.$Progress.start();
                    this.isLoadingQualityDistributionData = true;
                    this.loadQualityDistributionData(this.$route.params.ds_id)
                        .then(() => {
                            this.$Progress.finish();
                            this.checkDistributionValidation();
                        })
                        .catch(() => this.$Progress.fail())
                        .finally(() => this.isLoadingQualityDistributionData = false);
                }
            }

            // Duplicated API call, execute only if data not already loaded
            if (this.$route.params.ds_id !== this.getIsDQVDataRequested) {
                if (this.useDQVDataDropdown) {
                    this.$Progress.start();
                    this.loadDQVData({ id: this.$route.params.ds_id, formats: this.formats, locale: this.$route.query.locale })
                    .then(() => {
                        this.$Progress.finish();
                        $('[data-toggle="tooltip"]').tooltip({
                        container: 'body',
                        });
                    })
                    .catch(() => {
                        this.$Progress.fail();
                    });
                }
            }
        });
    },
    mounted() {},
};
</script>

<style lang="scss">
</style>
